pro ffft,y,dt,w,f,tl,fr,pp=pp,wf=wf

;this calculates the fft and returns the frequency subscripts too.
;
;IN    y: the dependant values
;      dt: sampling time
;
;OUT   w : the frequency array subscripts
;      f : the power
;      tl: total length of series
;      fr: frequency resolution
;
;OPTIONAL
;
;


n=0d
n=n_elements(y)
tl=dt*n     ;total length
fr=1./tl    ;frequ resolution
mn=n/2 +1  ;most negative subscript
mn2=(n+1)/2 ; find if its odd or even
h=2
if mn2 eq mn then h=1  ;odd


;frequency arrays
w=cindgen(n)
w[mn]=mn-n+cindgen(mn-h)
w=w/tl
f=((fft(y,-1)))

q=max(f,xval)
fval=w(xval)

w=shift(w,-mn)
f=shift(f,-mn)

;if i want to take out all the 1,2,3...c/d  (window function)
if keyword_set(wf) then begin
fint=ceil(w(0))
lint=floor(w(n_elements(w)-1))
k=lint-fint

        for i=fint,lint do begin
          ww=where(abs(w-i) le fr*5)
          x1=w(ww(0)-1)
          pf=f(ww(0)-1)
          x2=w(ww(n_elements(ww)-1)+1)
          af=f(ww(n_elements(ww)-1)+1)
          m=af-pf/(x2-x1)
          mn=(af + pf) / 2
          for j=0,n_elements(ww)-1 do f(ww(j))=mn 
        endfor


endif


if keyword_set(pp) then plot,w,f,xran=[0,fval*4]


end
